/* 
 * Program:             $RCSfile: AR4Sub.h,v $  $Revision: 30.48 $
 * 
 * Purpose:
 * 
 * Author:              Y.Momiyama  1995/10/01
 *                      S.Yamamoto  1996/07/13
 * 
 * (C) Copyright:       Y.Momiyama and S.Yamamoto  1995 - 2003
 *                      This file is a product of the project Sapid.
 */

#if !defined(_AR4SUB_H) && defined(SAPID_AR4_KERNEL)
#define _AR4SUB_H

/*
 * 饹ȥ֥ȤȤʬƤΤФơϢȤμΤǤ󥯤
 * ȤʬƤʤȤաޤSpdClassIdѿclassIdϡ饹
 * ϢξޤळȤΤդ뤳ȡ
 */

/*
 * classμֹʬäƤˤΤ߻Ȥȡ
 */
#define SPD_IS_CLS_ID(x)    (class_table[(x)].typ & C_TYP_OBJ)
#define SPD_IS_REL_ID(x)    (class_table[(x)].typ & C_TYP_REL)
#define SPD_IS_TYP_CMP(x)   (class_table[(x)].typ & C_TYP_CMP)

/******************************************************************************/

/*
 *                      Internal database type used in SpdCursor.
 */

/* Object arrays. */

extern SpdDBObj     *object_db;
extern int          object_db_n;
extern int          *object_name_key;

/* Relation arrays. */

extern SpdDBRel     *relation_db;
extern int          relation_db_n;

/* Class information. */

typedef struct {
    char        *name;
    SpdClassId  class_id;
    SpdClassId  rel_class1;
    SpdClassId  rel_class2;
    SpdModelId  modelId;        /* Added by S.Yamamoto 2000/05/08. */   
    int         typ;
    int         seq[IVAL_NUM + SpdObjSValN + 1];
    int         max_iattr;      /* (-1) if no integer attribute. */
    char        *iattr[IVAL_NUM];
    int         max_sattr;      /* (-1) if no string attribute. */
    char        *sattr[SpdObjSValN];

    /* Υ饹°ΤκǾֹ桥 */
    SpdId       min_id;
    /* Υ饹°Τκ缱ֹ桥 */
    SpdId       max_id;
    /* ǾֹļΤ{object,rel}_db[]ˤ֡ */
    int         min_index;
} Class_t;

extern Class_t class_table[];

/******************************************************************************/

/* 
 * ivalue[]ΥꥢפPurifyοǤ򥯥ꥢ뤿˹Ԥ
 * svalue[]ΥꥢspdFree()ΰɬפ뤫ݤȽ
 * ɬפǤ롥
 */
#define SPD_CLEAR_DB_ITEM(p, size)      memset((p), 0, (size))

/*
 * Added by S.Yamamoto 1998/09/02. 
 * Used only in spdGetAttrIdByName3().
 */

#define SPD_NON_ANAME_ID        (-1)

/******************************************************************************/

/* db.c */
void set_initial_db_num(SpdModelId modelId);
void append_object(SpdDBObj obj);
int append_relation(SpdDBRel rel);
void make_index(void);

SpdDBObj *db_get_object_id(SpdObjId objId);
SpdDBRel *db_get_relation_id(SpdRelId relId);

SpdDBRel *db_get_relation_p_id(SpdDBRelCursor *dp);
SpdDBRelCursor *db_get_relation_p_id_init(SpdClassId classId, SpdRelId p_id);
void db_get_relation_p_id_free(SpdDBRelCursor *dp);
SpdDBRel *db_get_relation_c_id(SpdDBRelCursor *dp);
SpdDBRelCursor *db_get_relation_c_id_init(SpdClassId classId, SpdRelId c_id);
void db_get_relation_c_id_free(SpdDBRelCursor *dp);

/* getObjid.c */
void db_get_object_name_free(SpdDBObjCursor *dp);

/* ar.c */
SpdRelId spdGetFileDeclRelId(SpdRelId relationId, SpdObjId fileId);
SpdCursor *spdAllocCursor(void);
SpdCursor *spdGetRelByAttrInit(SpdObjId objectId, SpdConstString relationName, SpdConstString attrName);
SpdRel spdGetRelByAttrRaw(SpdCursor *csr);
SpdRel spdGetRelByAttr(SpdCursor *csr);
SpdCursor *spdGetRelAnyInit(SpdObjId objectId, SpdConstString relationName);
SpdRel spdGetRelAny(SpdCursor *csr);

/* misc.c */
void *bxsearch(const void *key, const void *base, size_t nmemb,
               size_t size, int (*compar)(const void *, const void *));

/* read_sdb.c */
void read_obj_class(SpdClassId classId, int obj_num,
                    void (*fpReadAndInsert)(FILE *fp, SpdClassId classId));
void read_rel_class(SpdClassId classId, int obj_num,
                    void (*fpReadAndInsert)(FILE *fp, SpdClassId classId,
                                            SpdRelId id));
void spdReadAndInsertObj(FILE *fp, SpdClassId classId);
void spdReadAndInsertRel(FILE *fp, SpdClassId classId, SpdObjId id);
void spdSetReadSDBformat(int format);
int spdGetReadSDBformat(void);
SpdDBObj spdReadObj(FILE *fp, SpdClassId classId);
SpdDBRel spdReadRel(FILE *fp, SpdClassId classId, SpdRelId relId);
void spdFreeStrsInObj(SpdDBObj obj);

/* read_class.c */
void spdCreateBlockTable(SpdObjId ifileId);
void spdReleaseBlockTable(void);

/* spdGetSchema.c */
#ifdef OBSOLETE_000403
int spdGetAttrPos(SpdClassId classId, SpdString attrName);
#endif

/* spdGlobalObj.c */
SpdObjId spdSearchGlobalObj(SpdString className, SpdString name);
SpdObjId spdSearchGlobalObjEx(SpdString className, SpdString name);
SpdObjId spdCreateGlobalObj(SpdString className, SpdString name);
void spdWriteGlobalClass(SpdString className);

#endif /* !defined(_AR4SUB_H) && defined(SAPID_AR4_KERNEL) */
