/* 
 * Program:             $RCSfile: AR5.h,v $  $Revision: 30.29 $
 * 
 * Purpose:             AR5 header file.
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: AR5.h,v 30.29 2003/07/06 10:09:30 yamamoto Exp yamamoto $
 */ 

#if !defined(_SPD_AR5_H)
#define _SPD_AR5_H

/*
 *                      Constant definitions.
 */

#define SAPID_NON_VALUE             (-1)

#define SpdDBMaxFieldN              SPD_ISVAL_NUM

#define SAPID_INTBITS               32

#define SAPIDDB_PUBLIC              1       /* ݡȥ饹Υ */
#define SAPIDDB_PRIVATE             0

/* °ֹźֹ桥 */
#define SAPIDDB_ATTR_NONE           (-1)   /* °ĤʤȤ */
#define SAPIDDB_ATTR_ID             (-10)  /* ֥ID */
#define SAPIDDB_ATTR_CLASSID        (-11)  /* 饹ID */

/* Ƥclass->attrs[0], Ҥclass->attrs[1]ꤷƤ롥 */
#define SAPIDDB_ATTR_P_ID           0     /* Ϣοƥ֥Ȥ ID */
#define SAPIDDB_ATTR_C_ID           1     /* Ϣλҥ֥Ȥ ID */

/*
 * Error code.
 */

#define SAPID_ERR_CANT_OPEN_SDB         (-1)
#define SAPID_ERR_INVALID_SDB_FORMAT    (-2)
#define SAPID_ERR_INVALID_MODELID       (-3)
#define SAPID_ERR_INVALID_CLASSID       (-4)

/*
 *                      Type definitions.
 */

#include <Sapid/spdSet2.h>

typedef SpdSet2 SpdIdSet;

typedef SetCursor SpdCursor;

typedef struct SpdRegionIndex_t SpdRegionIndex;

#if defined(SAPID_AR5_KERNEL)
#include "AR5Sub.h"
#include <Sapid/SapidModel.h>
#endif

/*
 *                      Function prototypes.
 */

/* scheme.c */

SpdModelId spdUseModel(SpdDBModel *);

/* int spdGetModelNum(void); */
SpdConstString spdGetModelNameById(SpdModelId modelId);
SpdModelId spdGetModelIdByName(SpdConstString modelName);
SpdIdSet spdGetAllModels(void);

SpdModelId spdGetModelId(SpdClassId);
/* int spdGetClassNum(SpdModelId); */
SpdIdSet spdGetAllClasses(SpdModelId);
SpdConstString spdGetClassNameById(SpdClassId);
SpdClassId spddb_GetClassIdByName(SpdConstString, SpdModelId);
SpdClassId spdGetClassIdByName(SpdConstString);
int spdGetClassSort(SpdClassId);

int spdGetNumOfAttrs(SpdClassId);
SpdSet2 spdGetAllAttrNo(SpdClassId);
SpdConstString spdGetAttrNameByNo(SpdClassId, int);
int spdGetAttrNoByName(SpdClassId, SpdConstString);
SpdDBType spdGetAttrType(SpdClassId, int);

SpdConstString spdGetEnumStrVal(SpdClassId, int, int);
int spdGetEnumIntVal(SpdClassId, int, SpdConstString);

SpdBoolean spdIsValidModelId(SpdModelId modelId);

SpdClassId spdGetFirstCid(SpdModelId modelId);
SpdClassId spdGetLastCid(SpdModelId modelId);
SpdClassId spdGetFirstRid(SpdModelId modelId);
SpdClassId spdGetLastRid(SpdModelId modelId);

SpdBoolean spdIsValidClassOrRelationId(SpdClassId classId);
SpdBoolean spdIsValidClassId(SpdClassId classId);
SpdBoolean spdIsValidRelationId(SpdClassId relId);

/* object.c */

/* ǥեȤΥǡ١ */
SpdDBId spdSetDefaultDB(SpdDBId indId);
SpdDBId spdGetDefaultDB(void);

/* SapidDBνȽλ */
SpdDBId spdOpenSDB(void);
void spdCloseSDB(SpdDBId);

/* ֥Ȥľ */
SpdIdSet spdGetClassExtentP(SpdClassId);
SpdIdSet spdGetClassExtent(SpdClassId);
SpdId spdCreateObj(SpdClassId, SpdId);
SpdRelId spdCreateRel(SpdClassId, SpdRelId, SpdObjId, SpdObjId);
void spdDeleteObj(SpdId);

/* °ͼؿ */
SpdClassId spdGetClassId(SpdId);
int spdGetAttrIntVal(SpdId, int);
int spdGetAttrIntValByName(SpdId, SpdConstString);
SpdConstString spdGetAttrStrVal(SpdId, int);
SpdConstString spdGetAttrStrValByName(SpdId, SpdConstString);

/* °ؿ */
int spdSetAttrIntVal(SpdId, int, int);
int spdSetAttrIntValByName(SpdId, SpdConstString, int);
SpdConstString spdSetAttrStrVal(SpdId, int, SpdConstString);
SpdConstString spdSetAttrStrValByName(SpdId, SpdConstString, SpdConstString);

/* Ϣؿ */
SpdIdSet spdGetChildObjIdSet(SpdObjId id, SpdClassId relClassId);
SpdObjId spdGetAChildObjId(SpdObjId id, SpdClassId relClassId);
SpdIdSet spdGetChildObjIdSetWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                        SpdConstString objAttr, int objValue);
SpdObjId spdGetAChildObjIdWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                      SpdConstString objAttr, int objValue);
SpdIdSet spdGetChildObjIdSetWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                        SpdConstString relAttr, int relValue);
SpdObjId spdGetAChildObjIdWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                      SpdConstString relAttr, int relValue);
SpdIdSet spdGetParentObjIdSet(SpdObjId id, SpdClassId relClassId);
SpdObjId spdGetAParentObjId(SpdObjId id, SpdClassId relClassId);
SpdIdSet spdGetParentObjIdSetWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                         SpdConstString objAttr, int objValue);
SpdObjId spdGetAParentObjIdWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                       SpdConstString objAttr, int objValue);
SpdIdSet spdGetParentObjIdSetWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                         SpdConstString relAttr, int relValue);
SpdObjId spdGetAParentObjIdWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                       SpdConstString relAttr, int relValue);
SpdSet2 spdGetChildRelSet(SpdObjId id, SpdClassId relClassId);
SpdRel spdGetAChildRel(SpdObjId id, SpdClassId relClassId);
SpdSet2 spdGetChildRelSetWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                    SpdConstString objAttr, int objValue);
SpdRel spdGetAChildRelWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                  SpdConstString objAttr, int objValue);
SpdSet2 spdGetChildRelSetWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                    SpdConstString relAttr, int relValue);
SpdRel spdGetAChildRelWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                  SpdConstString relAttr, int relValue);
SpdSet2 spdGetParentRelSet(SpdObjId id, SpdClassId relClassId);
SpdRel spdGetAParentRel(SpdObjId id, SpdClassId relClassId);
SpdSet2 spdGetParentRelSetWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                     SpdConstString objAttr, int objValue);
SpdRel spdGetAParentRelWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                   SpdConstString objAttr, int objValue);
SpdSet2 spdGetParentRelSetWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                     SpdConstString relAttr, int relValue);
SpdRel spdGetAParentRelWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                   SpdConstString relAttr, int relValue);
SpdIdSet spdGetChildRelIdSet(SpdObjId id, SpdClassId relClassId);
SpdRelId spdGetAChildRelId(SpdObjId id, SpdClassId relClassId);
SpdIdSet spdGetChildRelIdSetWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                        SpdConstString objAttr, int objValue);
SpdRelId spdGetAChildRelIdWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                      SpdConstString objAttr, int objValue);
SpdIdSet spdGetChildRelIdSetWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                        SpdConstString relAttr, int relValue);
SpdRelId spdGetAChildRelIdWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                      SpdConstString relAttr, int relValue);
SpdIdSet spdGetParentRelIdSet(SpdObjId id, SpdClassId relClassId);
SpdRelId spdGetAParentRelId(SpdObjId id, SpdClassId relClassId);
SpdIdSet spdGetParentRelIdSetWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                         SpdConstString objAttr, int objValue);
SpdRelId spdGetAParentRelIdWithObjAttr(SpdObjId id, SpdClassId relClassId,
                                       SpdConstString objAttr, int objValue);
SpdIdSet spdGetParentRelIdSetWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                         SpdConstString relAttr, int relValue);
SpdRelId spdGetAParentRelIdWithRelAttr(SpdObjId id, SpdClassId relClassId,
                                       SpdConstString relAttr, int relValue);
/* read_db.c */

#ifdef DAPID
FILE *spdOpenDSDB_AR5(char *dname, int mode);
#endif

int spdReadAClass(SpdClassId classId, SpdDBId dbId);
int spdReadDB(SpdModelId modelId, SpdDBId dbId);
int spdCreateDB(SpdModelId modelId, SpdDBId dbId);

/* write_db.c */

int spdWriteAClass(SpdClassId classId, SpdDBId);
int spdCommitDB(SpdModelId, SpdDBId);

/* !! ץľܺؿ("libWriteTuple.a"ȤʬΥ)? */
/* 
 * int spdWriteDBCreateObj(SpdClassId, SpdObjId);
 * int spdWriteDBSetAttrIntVal(int attrNo, int value);
 * int spdWriteDBSetAttrStrVal(int attrNo, SpdConstString value);
 * int spdWriteDBCommitObj(SpdClassId, SpdObjId);
 */

/* util.c */
/* !! SpdUtilˤ٤Ρ */

int spdDBCalcHash(const char *);

/* AR.c */

SpdIdSet spdGetObjIdSet(SpdClassId classId, SpdConstString name);
SpdId spddbGetAnObjId(SpdClassId classId, SpdConstString name);
SpdSet2 spdGetRelSet(SpdObjId objectId, SpdClassId relClassId,
            SpdConstString attrName);
SpdIdSet spdGetRelObjSet(SpdObjId objectId, SpdClassId relClassId,
             SpdConstString attrName);
SpdIdSet spdGetRelIdSet(SpdObjId objectId1, SpdObjId objectId2,
            SpdClassId relClassId);

SpdSet2 spdSearchChildObj(SpdObjId objectId, SpdClassId target);
SpdSet2 spdSearchParentObj(SpdObjId objectId, SpdClassId target);

/* compat.c */

SpdConstString spdGetClassName(SpdId objectId);
int spdGetOffset(SpdRelId relationId);
SpdConstString spdGetName(SpdId objectId);
int spdGetLength(SpdId objectId);
int spdGetAttrValInt(SpdId objectId, SpdConstString attrName);
SpdConstString spdGetAttrValString(SpdId objectId, SpdConstString attrName);
int spdGetAttrValIntOfObj(SpdObjId objectId, SpdConstString attrName);
int spdGetAttrValIntOfRel(SpdRelId relationId, SpdConstString attrName);

void spdSetSearchFlag(int mode);
int spdGetSearchFlag(void);

int spdWriteClass(SpdClassId classId, SpdConstString dirName);

/* Ѥؿ */
void spdFreeCursor(SpdCursor *csr);

SpdCursor *spdGetObjIdInit(SpdConstString className, SpdConstString name);
SpdObjId spdGetObjId(SpdCursor *csr);
SpdObjId spdGetAnObjId(SpdConstString className, SpdConstString name);

SpdCursor *spdGetRelInit(SpdObjId objectId, SpdConstString relationName,
                         SpdConstString attrName);
SpdRel spdGetRel(SpdCursor *csr);
SpdRel spdGetARel(SpdObjId objectId, SpdConstString relationName,
                  SpdConstString attrName);

SpdCursor *spdGetRelObjInit(SpdObjId objectId, SpdConstString relationName,
                            SpdConstString attrName);
SpdRelId spdGetRelObj(SpdCursor *csr);
SpdRelId spdGetARelObj(SpdObjId objectId, SpdConstString relationName,
                       SpdConstString attrName);

SpdCursor *spdGetRelIdInit(SpdObjId objectId1, SpdObjId objectId2,
                           SpdConstString relationName);
SpdRelId spdGetRelId(SpdCursor *csr);
SpdRelId spdGetARelId(SpdObjId objectId1, SpdObjId objectId2,
                      SpdConstString relationName);

#endif /* !defined(_SPD_AR5_H) */
