/* 
 * Program:             $RCSfile: AR5Sub.h,v $  $Revision: 30.20 $
 * 
 * Purpose:             ؿѥإåե롥
 * 
 * Author:              T.Hidaka  1998/05/21
 *                      S.Yamamoto  1998/05/23
 * 
 * (C) Copyright:       T.Hidaka and S.Yamamoto  1998 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: AR5Sub.h,v 30.20 2003/08/16 10:32:56 yamamoto Exp yamamoto $
 */ 

/* 
 * Type definition.
 */

/* Attribute values. */

typedef union _SpdDBValue_t {
    int         ivalue;
    SpdString   svalue;
} SpdDBValue;

/* Instance data. */
/* ϥ饹ɬפʥǡϰۤʤ롥 */

typedef struct _SpdDBObj_t {
    SpdId id;                            /* ֥ ID */
    SpdClassId classId;                  /* 饹 ID */
    SpdDBValue *value;
} SpdDBObj;

/* Attribute. */

typedef struct _SpdDBAttr_t {
    const char  *name;      /* °̾ */
    SpdDBType   type;       /*  */
    SpdValName  *enums;     /* 󷿥ݥ (type  Enum ΤȤ)*/
    SpdClassId  classId;    /* 饹ID       (type  oid ΤȤ) */
    int         bitwidth;   /* ӥå       (type  Integer ΤȤ) */

    /* 
     * For compatibility with "<SAPID_TOP>/analyzer/jdbin/DBTable.c".
     * Added by S.Yamamoto 2003/04/06.
     */
    int         offset;                     /* Offset in SymData. */
    int         unionOffset;                /* Offset in SymData.u, */
                                            /* -1 means this attr is not member of uion. */

    int seq;              /* @ ͤź */
    int firstbit;         /* @ ϥӥåȿ (type  Integer ΤȤ) */
    int hash;             /* @ °̾Υϥå */
} SpdDBAttr;

/* Class. */

typedef struct _SpdDBClass_t {
    const char *name;               /* 饹̾ */
    SpdClassId id;                  /* 饹ID */
    int sort;                       /* 饹(Ƥ) */
    int fields[SpdDBMaxFieldN];     /* եΥեɤ°бɽ */
                                    /* fields[fieldNo] °ֹ򤤤 */
    SpdDBAttr attrs[SPD_ISVAL_NUM]; /* °ꥹ */ 
    SpdModelId modelId;             /* @ ° modelID */
    int hash;                       /* @ 饹̾Υϥå */
    int nAttrs;                     /* @ ° */
    int nValues;                    /* @ SpdDBValueο */
} SpdDBClass;

typedef struct _SpdDBImport_t {
    SpdClassId classId;             /* ݡȥ饹 ID */
    SpdBoolean access;              /* public ʤ TRUE */
} SpdDBImportClass;

/* Model. */

/* Moved into "<SAPID_TOP>/AR/AR3/SapidModel.h" by S.Yamamoto 2000/04/08. */
/* 
 * struct _SpdDBModel_t {
 *     ...
 * };
 */

/* Indexes of offset and length. */

typedef struct SpdRegionIndexNode_t {
    SpdRelId relationId;
    int offset;
    int length;
} SpdRegionIndexNode;

struct SpdRegionIndex_t {
    SpdObjId parentId;
    int size;
    SpdRegionIndexNode *nodes;
};

/* 
 * Function prototypes.
 */

/* scheme.c */

int spddb_GetAttrSeq(SpdClassId, int);
int spddb_GetValueNum(SpdClassId classId);
void spddb_FreeDBObjValue(SpdDBObj *obj);
void spddb_InitDBObjValue(SpdDBObj *obj);
SpdObjId spddb_ReadTuple(FILE *, SpdClassId, SpdDBObj *);
SpdObjId spddb_WriteTuple(FILE *, SpdClassId, SpdId);
int spddb_GetAttrBitfieldVal(SpdClassId classId, int attrNo, int ivalue);
int spddb_SetAttrBitfieldVal(SpdClassId classId, int attrNo,
                             int ivalue, int value);
void spdSetDBPathOfModel(SpdModelId modelId, SpdConstString pathname);
SpdConstString spdGetDBPathOfModel(SpdModelId);

/* Added by S.Yamamoto 2001/03/29. */
SpdDBModel *spdGetDBModelById(SpdModelId modelId);
SpdDBClass *spdGetDBClassById(SpdClassId classId);

/* object.c */

void spddb_UnRegisterDBObj(SpdId id, SpdDBId dbId);
SpdId spddb_RegisterDBObj(SpdDBObj *, SpdDBId dbId);
SpdDBObj spddb_CreateDBObj(SpdClassId classId, SpdId objId);
SpdDBObj *spddb_GetDBObjById(SpdId id);
/* 
 * SpdDBId spddb_CreateDBIndex(int uniqObjId, int uniqRelId);
 * void spddb_FreeDBIndex(SpdDBId dbId);
 */
void spddb_FreeAllDBIndex(void);
void spddb_WriteSDBInfo(SpdInfo *info, SpdDBId dbId);

#ifdef DAPID

/* ֥ */
SpdDBObj spdCreateTempObj(SpdClassId classId, SpdObjId objId);
void spdDeleteTempObj(SpdDBObj *obj);
SpdConstString spdSetTempObjAttrStrValByName(SpdDBObj *obj,
                                             SpdConstString attrName,
                                             SpdConstString value);
int spdSetTempObjAttrIntValByName(SpdDBObj *obj,
                                  SpdConstString attrName,
                                  int value);
SpdConstString spdGetTempObjAttrStrValByName(SpdDBObj *obj,
                                             SpdConstString attrName);
int spdGetTempObjAttrIntValByName(SpdDBObj *obj, SpdConstString attrName);
SpdObjId spdWriteTempObj(FILE *fp, SpdDBObj* obj);
SpdObjId spdReadTempObj(FILE *fp, SpdClassId classId, SpdDBObj *obj);

#endif /* DAPID */

/* read_db.c */

/* write_db.c */

void spddb_CreateTuple(FILE *fp);
void spddb_CommitTuple(FILE *fp);
const char *spddb_WriteStrVal(FILE *, const char *);
int spddb_WriteIntVal(FILE *, int);

/* util.c */

/* AR.c */

/* compat.c */

SpdCursor *spddb_CreateCursor(SpdSet2 set);
SpdElem *spddb_IterCursor(SpdCursor *csr);

/* regindex.c */

SpdRegionIndex spddb_createRegionIndex(SpdObjId parentId, 
                                       SpdClassId relClassId);
SpdRegionIndexNode *spddb_searchRegionIndex(SpdRegionIndex *regIndex,
                                            int offset);
void spddb_freeRegionIndex(SpdRegionIndex *regIndex);
