/* 
 * Program:             $RCSfile: CommentViewAR.h,v $  $Revision: 40.5 $
 * 
 * Purpose:             Access routines of CommentView.
 * 
 * Author:              K.Hoshino  2001/10/27
 *                      S.Yamamoto  2001/10/27 
 * 
 * (C) Copyright:       K.Hoshino and S.Yamamoto  2001
 *                      This file is a product of the project Sapid.
 */

#ifndef _SAPID_COMMENT_VIEW_AR_H
#define _SAPID_COMMENT_VIEW_AR_H

/*
 * Prototypes.
 */

SpdIdSet getAllPcomments(void);
SpdIdSet getAllLcomments(void);

SpdIdSet getPcommentsInPfile(SpdObjId pfileId);
SpdObjIdArray getPcommentsInPfileSorted(SpdObjId pfileId);
SpdIdSet getLcommentsInPfile(SpdObjId pfileId);
SpdObjIdArray getLcommentsInPfileSorted(SpdObjId pfileId);
SpdObjIdArray getLcommentsWithinRegionP(SpdRegion regionP);

SpdObjId getLcomment(SpdObjId pcommentId);
SpdIdSet getPhygicalComments(SpdObjId lcommentId);

SpdObjId getARelatedLcomment(SpdObjId elementId);
SpdIdSet getRelatedLcomments(SpdObjId elementId);
SpdObjId getRelatedElementId(SpdObjId rcommentId);

SpdConstString getLcommentString(SpdObjId lcomment);

SpdObjId getLcommentFile(SpdObjId lcommentId);

int getLcommentLength(SpdObjId lcommentId);
int getLcommentOffset(SpdObjId lcommentId);
int getLcommentLineNumBegin(SpdObjId lcommentId);
int getLcommentLineNumEnd(SpdObjId lcommentId);
int getLcommentOffsetFromLineHead(SpdObjId lcommentId);
void getLcommentPositionInfos(SpdObjId lcommentId, int *length, int *offset,
                                    int *lineNumBegin, int *lineNumEnd, int *offsetFromLinehead);

SpdObjIdArray getLcommentsOnReference(SpdObjId declarator);

#endif /* _SAPID_COMMENT_VIEW_AR_H */

/* public_func.c */

int getOffsetFromLineHead(int offset, SpdString sourceStr);
int getLineNum(int offset, SpdString sourceStr);

SpdString getSourceFileString(SpdObjId fileId, int offset, int length);
SpdString getSubString(SpdString buf, int offset, int length);

