/* 
 * Program:             $RCSfile: Jmodel.h,v $  $Revision: 40.9 $
 * 
 * Purpose:             Class definition of J-model.
 * 
 * Author:              S.Yamamoto  2002/07/10
 * 
 * (C) Copyright:       S.Yamamoto  2002 - 2003
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: Jmodel.h,v 40.9 2003/02/20 15:12:46 yamamoto Exp yamamoto $
 */ 

#if !defined(_SAPID_J_MODEL_H)
#define _SAPID_J_MODEL_H

/* Class id. */

/* 
 * Note: 
 * (1) SPD_CID_J_SPECIAL means this, super, null, true and false.
 */

#define SPD_CID_J_FILE              (SPD_FIRST_CID_J_MODEL + 0)
#define SPD_CID_J_CLASS             (SPD_FIRST_CID_J_MODEL + 1)
#define SPD_CID_J_INTERFACE         (SPD_FIRST_CID_J_MODEL + 2)
#define SPD_CID_J_VARIABLE          (SPD_FIRST_CID_J_MODEL + 3)
#define SPD_CID_J_ROUTINE           (SPD_FIRST_CID_J_MODEL + 4)
#define SPD_CID_J_TYPE              (SPD_FIRST_CID_J_MODEL + 5)
#define SPD_CID_J_MODIFIER          (SPD_FIRST_CID_J_MODEL + 6)
#define SPD_CID_J_SBLOCK            (SPD_FIRST_CID_J_MODEL + 7)
#define SPD_CID_J_STATEMENT         (SPD_FIRST_CID_J_MODEL + 8)
#define SPD_CID_J_EXPRESSION        (SPD_FIRST_CID_J_MODEL + 9)
#define SPD_CID_J_LITERAL           (SPD_FIRST_CID_J_MODEL + 10)
#define SPD_CID_J_OPERATOR          (SPD_FIRST_CID_J_MODEL + 11)
#define SPD_CID_J_QNAME             (SPD_FIRST_CID_J_MODEL + 12)
#define SPD_CID_J_SPECIAL           (SPD_FIRST_CID_J_MODEL + 13)
#define SPD_CID_J_LABEL             (SPD_FIRST_CID_J_MODEL + 14)
#define SPD_CID_J_COMMENT           (SPD_FIRST_CID_J_MODEL + 15)
#define SPD_CID_J_WILDCARD          (SPD_FIRST_CID_J_MODEL + 16)

#if (SPD_CID_J_WILDCARD != SPD_LAST_CID_J_MODEL)
    "Invalid configuration."
#endif

#define SPD_CID_NUM_J_MODEL \
        (SPD_LAST_CID_J_MODEL - SPD_FIRST_CID_J_MODEL + 1)

/* Relation id. */

#define SPD_RID_J_DEFINE_PACKAGE        (SPD_FIRST_RID_J_MODEL + 0)
#define SPD_RID_J_IMPORT_PACKAGE        (SPD_FIRST_RID_J_MODEL + 1)
#define SPD_RID_J_DEFINE_CLASS          (SPD_FIRST_RID_J_MODEL + 2)
#define SPD_RID_J_IMPLEMENT_INTERFACE   (SPD_FIRST_RID_J_MODEL + 3)
#define SPD_RID_J_EXTEND_CLASS          (SPD_FIRST_RID_J_MODEL + 4)
#define SPD_RID_J_CLASS_MODIFIER        (SPD_FIRST_RID_J_MODEL + 5)
#define SPD_RID_J_CLASS_VARIABLE        (SPD_FIRST_RID_J_MODEL + 6)
#define SPD_RID_J_CLASS_ROUTINE         (SPD_FIRST_RID_J_MODEL + 7)
#define SPD_RID_J_CLASS_SBLOCK          (SPD_FIRST_RID_J_MODEL + 8)
#define SPD_RID_J_CLASS_ARGUMENT        (SPD_FIRST_RID_J_MODEL + 9)
#define SPD_RID_J_CLASS_CLASS           (SPD_FIRST_RID_J_MODEL + 10)
#define SPD_RID_J_CLASS_INTERFACE       (SPD_FIRST_RID_J_MODEL + 11)
#define SPD_RID_J_DEFINE_INTERFACE      (SPD_FIRST_RID_J_MODEL + 12)
#define SPD_RID_J_EXTEND_INTERFACE      (SPD_FIRST_RID_J_MODEL + 13)
#define SPD_RID_J_INTERFACE_MODIFIER    (SPD_FIRST_RID_J_MODEL + 14)
#define SPD_RID_J_INTERFACE_VARIABLE    (SPD_FIRST_RID_J_MODEL + 15)
#define SPD_RID_J_INTERFACE_ROUTINE     (SPD_FIRST_RID_J_MODEL + 16)
#define SPD_RID_J_INTERFACE_CLASS       (SPD_FIRST_RID_J_MODEL + 17)
#define SPD_RID_J_INTERFACE_INTERFACE   (SPD_FIRST_RID_J_MODEL + 18)
#define SPD_RID_J_VARIABLE_MODIFIER     (SPD_FIRST_RID_J_MODEL + 19)
#define SPD_RID_J_VARIABLE_TYPE         (SPD_FIRST_RID_J_MODEL + 20)
#define SPD_RID_J_INITIALIZE_VARIABLE   (SPD_FIRST_RID_J_MODEL + 21)
#define SPD_RID_J_PARAMETER_VARIABLE    (SPD_FIRST_RID_J_MODEL + 22)
#define SPD_RID_J_RETURN_TYPE           (SPD_FIRST_RID_J_MODEL + 23)
#define SPD_RID_J_THROW_TYPE            (SPD_FIRST_RID_J_MODEL + 24)
#define SPD_RID_J_ROUTINE_BODY          (SPD_FIRST_RID_J_MODEL + 25)
#define SPD_RID_J_ROUTINE_MODIFIER      (SPD_FIRST_RID_J_MODEL + 26)
#define SPD_RID_J_TYPE_CLASS            (SPD_FIRST_RID_J_MODEL + 27)
#define SPD_RID_J_TYPE_INTERFACE        (SPD_FIRST_RID_J_MODEL + 28)
#define SPD_RID_J_TYPE_TYPE             (SPD_FIRST_RID_J_MODEL + 29)
#define SPD_RID_J_TYPE_QNAME            (SPD_FIRST_RID_J_MODEL + 30)
#define SPD_RID_J_QNAME_QNAME           (SPD_FIRST_RID_J_MODEL + 31)
#define SPD_RID_J_QNAME_DOT             (SPD_FIRST_RID_J_MODEL + 32)
#define SPD_RID_J_SBLOCK_BODY           (SPD_FIRST_RID_J_MODEL + 33)
#define SPD_RID_J_LOCAL_CLASS           (SPD_FIRST_RID_J_MODEL + 34)
#define SPD_RID_J_LOCAL_VARIABLE        (SPD_FIRST_RID_J_MODEL + 35)
#define SPD_RID_J_STATEMENT_LABEL       (SPD_FIRST_RID_J_MODEL + 36)
#define SPD_RID_J_STATEMENT_STATEMENT   (SPD_FIRST_RID_J_MODEL + 37)
#define SPD_RID_J_STATEMENT_EXPRESSION  (SPD_FIRST_RID_J_MODEL + 38)
#define SPD_RID_J_REFER_LABEL           (SPD_FIRST_RID_J_MODEL + 39)
#define SPD_RID_J_CASE_VALUE            (SPD_FIRST_RID_J_MODEL + 40)
#define SPD_RID_J_EXPRESSION_OPERAND    (SPD_FIRST_RID_J_MODEL + 41)
#define SPD_RID_J_EXPRESSION_OPERATOR   (SPD_FIRST_RID_J_MODEL + 42)
#define SPD_RID_J_EXPRESSION_EXPRESSION (SPD_FIRST_RID_J_MODEL + 43)
#define SPD_RID_J_REFER_VARIABLE        (SPD_FIRST_RID_J_MODEL + 44)
#define SPD_RID_J_REFER_LITERAL         (SPD_FIRST_RID_J_MODEL + 45)
#define SPD_RID_J_REFER_SPECIAL         (SPD_FIRST_RID_J_MODEL + 46)
#define SPD_RID_J_REFER_TYPE            (SPD_FIRST_RID_J_MODEL + 47)
#define SPD_RID_J_REFER_QNAME           (SPD_FIRST_RID_J_MODEL + 48)
#define SPD_RID_J_HAS_TYPE              (SPD_FIRST_RID_J_MODEL + 49)
#define SPD_RID_J_INVOKE_ROUTINE        (SPD_FIRST_RID_J_MODEL + 50)
#define SPD_RID_J_SYMBOL_COMMENT        (SPD_FIRST_RID_J_MODEL + 51)

#if (SPD_RID_J_SYMBOL_COMMENT != SPD_LAST_RID_J_MODEL)
    "Invalid configuration."
#endif

/* Number of all classes and relations. */

#define SPD_CRID_NUM_J_MODEL \
        (SPD_CID_NUM_J_MODEL + SPD_RID_NUM_J_MODEL)

#define SPD_RID_NUM_J_MODEL \
        (SPD_LAST_RID_J_MODEL - SPD_FIRST_RID_J_MODEL + 1)

/******************************************************************************/

#define SPD_J_MODEL_VERSION         1

extern SpdDBModel J_model;

#endif /* !defined(_SAPID_J_MODEL_H) */
