/* 
 * Program:             $RCSfile: SapidModel.h,v $  $Revision: 30.4 $
 * 
 * Purpose:
 * 
 * Author:              S.Yamamoto  2000/04/08
 * 
 * (C) Copyright:       S.Yamamoto  2000
 *                      This file is a product of the project Sapid.
 */

/* 
 * $Id: SapidModel.h,v 30.4 2000/07/16 08:47:47 yamamoto Exp yamamoto $
 */ 

#if !defined(_SAPID_MODEL_H)
#define _SAPID_MODEL_H

/*
 * Definition of model.
 */

struct _SpdDBModel_t {
    SpdModelId          id;             /* Model id. */
    SpdConstString      name;           /* Model name. */
    int                 version;        /* Version number. */
    SpdConstString      pathname;       /* Directory for DB. */
    
    /**************************************************************************/

    /* 
     * Addeb by S.Yamamoto 2000/04/09.
     */

    SpdClassId          firstCid;       /* First class id. */ 
    SpdClassId          lastCid;        /* Last class id. */
    int                 numOfClasses;   /* Number of classes. */
    
    SpdClassId          firstRid;       /* First relationship id. */ 
    SpdClassId          lastRid;        /* Last relationship id. */ 
    int                 numOfRelations; /* Number of relationships. */
    
    int                 numOfAll;       /* (numOfClasses + numOfRelations). */
    
#if defined(SAPID_AR4)

    /* Internal use only. */
    SpdBoolean          used;           /* spdUseModel() was called or not. */
    SpdBoolean          read;           /* spdReadDB() was called or not. */
    SpdBoolean          created;        /* spdCreateSDB() was called or not. */

#elif defined(SAPID_AR5)

    SpdDBClass          *classes;   /* 饹 */
    SpdDBImportClass    *imports;   /* ݡȥ饹id */

    int                 nClasses;   /* @ 饹ο
                                       (ݡȥ饹ϴޤޤʤ) */
    int                 nImports;   /* @ ݡȥ饹ο */
    int                 hash;       /* @ ǥ̾Υϥå͡ */

#endif /* defined(SAPID_AR5) */
};

#endif /* !defined(_SAPID_MODEL_H) */
