<?xml version="1.0" encoding="Shift_JIS"?>

<!--
# 
# Program:		$RCSfile: outline.xsl,v $  $Revision: 50.2 $
# 
# Purpose:		
# 
# Author:		T.Takahashi  2003/10/30
# Author:		S.Yamamoto  2003/10/30
# 
# (C) Copyright:	T.Takahashi and S.Yamamoto  2003
#			This file is a product of the project Sapid.
# 
-->

<!--
    $Id: outline.xsl,v 50.2 2003/11/01 08:55:03 yamamoto Exp yamamoto $
-->  

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  version="1.0">
  <xsl:output method="xml" omit-xml-declaration="yes"
    encoding="Shift_JIS" indent="yes"/>

  <xsl:template match="/">
    <xsl:apply-templates/>
  </xsl:template>

  <xsl:template match="Import[1]">
    <xsl:for-each select="/File/Import">
      <Import>
        <xsl:attribute name="id">
          <xsl:value-of select="@id"/>
        </xsl:attribute>
        <QName>
          <xsl:value-of select="QName"/>
        </QName>
      </Import>
    </xsl:for-each>
  </xsl:template>

  <xsl:template match="Package[1]">
    <xsl:for-each select="/File/Package">
      <Package>
        <xsl:attribute name="id">
          <xsl:value-of select="@id"/>
        </xsl:attribute>
        <QName>
          <xsl:value-of select="QName"/>
        </QName>
      </Package>
    </xsl:for-each>
  </xsl:template>

  <xsl:template match="Class|Intf">
    <xsl:element name="{name()}">
      <xsl:attribute name="id">
        <xsl:value-of select="@id"/>
      </xsl:attribute>
      <ident>
        <xsl:value-of select="ident"/>
      </ident>
      <Members>

        <xsl:for-each select="Members/Field">
          <Field>
            <xsl:attribute name="id">
              <xsl:value-of select="@id"/>
            </xsl:attribute>
            <xsl:apply-templates select="kw|Type"/>
            <ident>
              <xsl:value-of select="ident"/>
            </ident>
          </Field>
        </xsl:for-each>

        <xsl:for-each select="Members/Ctor|Members/Method">
          <xsl:element name="{name()}">
            <xsl:attribute name="id">
              <xsl:value-of select="@id"/>
            </xsl:attribute>
            <xsl:apply-templates select="kw|Type"/>
            <ident>
              <xsl:value-of select="ident"/>
              <xsl:apply-templates select="Param|op"/>
            </ident>
          </xsl:element>
        </xsl:for-each>


        <xsl:for-each select="Members/Intf">
          <xsl:apply-templates select="../Intf"/>
        </xsl:for-each>

        <xsl:for-each select="Members/Class">
          <xsl:apply-templates select="../Class"/>
        </xsl:for-each>

      </Members>
    </xsl:element>
  </xsl:template>

  <xsl:template match="Method/kw|Method/Type|Ctor/kw|Field/Type|Field/kw">
    <xsl:element name="{name()}">
      <xsl:value-of select="."/>
    </xsl:element>
  </xsl:template>

  <xsl:template match="Param|Method/op|Ctor/op">
    <xsl:value-of select="."/>
  </xsl:template>

  <xsl:template match="text()|@*">
    <xsl:apply-templates/>
  </xsl:template>
</xsl:stylesheet>
