# 
# Program:              $RCSfile: SetUp.src,v $  $Revision: 30.37 $
# 
# Purpose:              Set up your environment.
# 
# Author:               H.Ariga  1994/10/15
#                       S.Yamamoto  1994/10/15
# 
# (C) Copyright:        H.Ariga and S.Yamamoto  1994 - 2003
#                       This file is a product of the project Sapid.
# 

# 
# $Id: SetUp.src,v 30.37 2003/10/03 15:09:38 yamamoto Exp yamamoto $
# 

# 
# Add below lines to your ".cshrc", if you use csh or tcsh.
# 
# if (-r "C:/cygwin/usr/local/Sapid-GCC/lib/SetUp") then
#     source "C:/cygwin/usr/local/Sapid-GCC/lib/SetUp"
# endif
# 
# Add below lines to your ".profile", if you use sh or bash.
# 
# if [ -r "C:/cygwin/usr/local/Sapid-GCC/lib/SetUp" ]; then
#     . "C:/cygwin/usr/local/Sapid-GCC/lib/SetUp.sh"
# fi
# 

# 
# For bourne shell.
# 

# export SAPID_BINDIR
# export SAPID_LIBDIR
# export SAPID_MKHTML_LIBDIR
# export SAPID_SAT_LIBDIR
# export SAPID_SDB_CONFDIR
# export SAPID_SIP_LIBDIR
# export SAPID_TCLAR_LIBDIR

# export SPD_DEF_BEFORE
# export SPD_DEF_AFTER
# export SPD_DEF_ANSI_BEFORE
# export SPD_DEF_ANSI_AFTER
# export SPD_DEF_GCC
# export SPD_INCLUDE_PATH

# export CLASSPATH
# export PURIFYOPTIONS
# export TCL_LIBRARY
# export TK_LIBRARY

# 
# Set path variable.
# 

set path = ("C:/cygwin/usr/local/Sapid-GCC/bin" $path)

# 
# Set Sapid environment variables.
# 

setenv SAPID_BINDIR         "C:/cygwin/usr/local/Sapid-GCC/bin"
setenv SAPID_LIBDIR         "C:/cygwin/usr/local/Sapid-GCC/lib"
setenv SAPID_SDB_CONFDIR    "C:/cygwin/usr/local/Sapid-GCC/lib"

setenv SAPID_SAT_LIBDIR     "C:/cygwin/usr/local/Sapid-GCC/lib"
setenv SAPID_SDA_LIBDIR     "C:/cygwin/usr/local/Sapid-GCC/lib"
setenv SAPID_SIP_LIBDIR     "C:/cygwin/usr/local/Sapid-GCC/lib"
setenv SAPID_SPE_LIBDIR     "C:/cygwin/usr/local/Sapid-GCC/lib"
setenv SAPID_TCLAR_LIBDIR   "C:/cygwin/usr/local/Sapid-GCC/lib"

setenv SAPID_MKHTML_LIBDIR  "C:/cygwin/usr/local/Sapid-GCC/lib/spdMkHtml"

setenv SPD_INCLUDE_PATH     "-IC:/cygwin/usr/local/Sapid-GCC/fixed-include"

# 
# Set general environment variables.
# 

# For only Cygwin environment.
setenv TCL_LIBRARY          "C:/cygwin/usr/share/tcl8.4"
setenv TK_LIBRARY           "C:/cygwin/usr/share/tk8.4"

if (${?TEXINPUTS} == 1) then
    setenv TEXINPUTS "C:/cygwin/usr/local/Sapid-GCC/lib/tex;${TEXINPUTS}"
else
    setenv TEXINPUTS "C:/cygwin/usr/local/Sapid-GCC/lib/tex"
endif

if (${?XAPPLRESDIR} == 1) then
    setenv XAPPLRESDIR "C:/cygwin/usr/local/Sapid-GCC/lib/X11/app-defaults;${XAPPLRESDIR}"
else
    setenv XAPPLRESDIR "C:/cygwin/usr/local/Sapid-GCC/lib/X11/app-defaults"
endif

# 
# Set Purify environment variables.
# 

if (-r "C:/cygwin/usr/local/Sapid-GCC/src") then
    if (${?PURIFYOPTIONS} == 1) then
        setenv PURIFYOPTIONS "-user-path=C:/cygwin/usr/local/Sapid-GCC/src ${PURIFYOPTIONS}"
    else
        setenv PURIFYOPTIONS "-user-path=C:/cygwin/usr/local/Sapid-GCC/src"
    endif
endif

# 
# Japid.
# 

if (${?CLASSPATH} == 1) then
    setenv CLASSPATH "C:/cygwin/usr/local/Sapid-GCC/class/Japid3.jar;C:/cygwin/usr/local/Sapid-GCC/class/Wapid.jar;C:/cygwin/usr/local/Sapid-GCC/class/java-getopt-1.0.9.jar;C:/cygwin/usr/local/Sapid-GCC/class/jtool-1.2.jar;${CLASSPATH}"
else
    setenv CLASSPATH "C:/cygwin/usr/local/Sapid-GCC/class/Japid3.jar;C:/cygwin/usr/local/Sapid-GCC/class/Wapid.jar;C:/cygwin/usr/local/Sapid-GCC/class/java-getopt-1.0.9.jar;C:/cygwin/usr/local/Sapid-GCC/class/jtool-1.2.jar;."
endif

if (${?JAVA_HOME} == 1) then
    setenv CLASSPATH "${JAVA_HOME}/lib/tools.jar;${CLASSPATH}"
endif

# unlimit descriptors

# 
# Set PIDB environment variables.
# 

if (! -x "C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts") then
    exit
endif

setenv SPD_DEF_BEFORE       "`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -D`"
setenv SPD_DEF_AFTER        "`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -I`"

setenv SPD_DEF_ANSI_BEFORE  "`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -D -a`"
setenv SPD_DEF_ANSI_AFTER   "`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -I -a`"

setenv SPD_DEF_GCC          "`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -D -g`"
setenv SPD_INCLUDE_PATH     "-IC:/cygwin/usr/local/Sapid-GCC/fixed-include"

# Use include files fixed by gcc in Solaris.

if (-x /bin/uname) then
    if ("`/bin/uname`" == "SunOS") then
        setenv SPD_DEF_AFTER "`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -I -l` ${SPD_DEF_AFTER}"
        setenv SPD_DEF_ANSI_AFTER "`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -I -a -l` ${SPD_DEF_ANSI_AFTER}"
    endif
endif
