# 
# Program:              $RCSfile: SetUp.src,v $  $Revision: 30.37 $
# 
# Purpose:              Set up your environment.
# 
# Author:               H.Ariga  1994/10/15
#                       S.Yamamoto  1994/10/15
# 
# (C) Copyright:        H.Ariga and S.Yamamoto  1994 - 2003
#                       This file is a product of the project Sapid.
# 

# 
# $Id: SetUp.src,v 30.37 2003/10/03 15:09:38 yamamoto Exp yamamoto $
# 

# 
# Add below lines to your ".cshrc", if you use csh or tcsh.
# 
# if (-r "C:/cygwin/usr/local/Sapid-GCC/lib/SetUp") then
#     source "C:/cygwin/usr/local/Sapid-GCC/lib/SetUp"
# endif
# 
# Add below lines to your ".profile", if you use sh or bash.
# 
# if [ -r "C:/cygwin/usr/local/Sapid-GCC/lib/SetUp" ]; then
#     . "C:/cygwin/usr/local/Sapid-GCC/lib/SetUp.sh"
# fi
# 

# 
# For bourne shell.
# 

export SAPID_BINDIR
export SAPID_LIBDIR
export SAPID_MKHTML_LIBDIR
export SAPID_SAT_LIBDIR
export SAPID_SDB_CONFDIR
export SAPID_SIP_LIBDIR
export SAPID_TCLAR_LIBDIR

export SPD_DEF_BEFORE
export SPD_DEF_AFTER
export SPD_DEF_ANSI_BEFORE
export SPD_DEF_ANSI_AFTER
export SPD_DEF_GCC
export SPD_INCLUDE_PATH

export CLASSPATH
export PURIFYOPTIONS
export TCL_LIBRARY
export TK_LIBRARY

# 
# Set path variable.
# 

PATH=/usr/local/Sapid-GCC/bin:${PATH}

# 
# Set Sapid environment variables.
# 

SAPID_BINDIR="C:/cygwin/usr/local/Sapid-GCC/bin"
SAPID_LIBDIR="C:/cygwin/usr/local/Sapid-GCC/lib"
SAPID_SDB_CONFDIR="C:/cygwin/usr/local/Sapid-GCC/lib"

SAPID_SAT_LIBDIR="C:/cygwin/usr/local/Sapid-GCC/lib"
SAPID_SDA_LIBDIR="C:/cygwin/usr/local/Sapid-GCC/lib"
SAPID_SIP_LIBDIR="C:/cygwin/usr/local/Sapid-GCC/lib"
SAPID_SPE_LIBDIR="C:/cygwin/usr/local/Sapid-GCC/lib"
SAPID_TCLAR_LIBDIR="C:/cygwin/usr/local/Sapid-GCC/lib"

SAPID_MKHTML_LIBDIR="C:/cygwin/usr/local/Sapid-GCC/lib/spdMkHtml"

SPD_INCLUDE_PATH="-IC:/cygwin/usr/local/Sapid-GCC/fixed-include"

# 
# Set general environment variables.
# 

# For only Cygwin environment.
TCL_LIBRARY="C:/cygwin/usr/share/tcl8.4"
TK_LIBRARY="C:/cygwin/usr/share/tk8.4"

if [ "${TEXINPUTS}" != "" ]; then
    TEXINPUTS="C:/cygwin/usr/local/Sapid-GCC/lib/tex;${TEXINPUTS}"
else
    TEXINPUTS="C:/cygwin/usr/local/Sapid-GCC/lib/tex"
fi

if [ "${XAPPLRESDIR}" != "" ]; then
    XAPPLRESDIR="C:/cygwin/usr/local/Sapid-GCC/lib/X11/app-defaults;${XAPPLRESDIR}"
else
    XAPPLRESDIR="C:/cygwin/usr/local/Sapid-GCC/lib/X11/app-defaults"
fi

# 
# Set Purify environment variables.
# 

if [ -r "C:/cygwin/usr/local/Sapid-GCC/src" ]; then
    if [ "${PURIFYOPTIONS}" != "" ]; then
        PURIFYOPTIONS="-user-path=C:/cygwin/usr/local/Sapid-GCC/src ${PURIFYOPTIONS}"
    else
        PURIFYOPTIONS="-user-path=C:/cygwin/usr/local/Sapid-GCC/src"
    fi
fi

# 
# Japid.
# 

if [ "${CLASSPATH}" != "" ]; then
    CLASSPATH="C:/cygwin/usr/local/Sapid-GCC/class/Japid3.jar;C:/cygwin/usr/local/Sapid-GCC/class/Wapid.jar;C:/cygwin/usr/local/Sapid-GCC/class/java-getopt-1.0.9.jar;C:/cygwin/usr/local/Sapid-GCC/class/jtool-1.2.jar;${CLASSPATH}"
else
    CLASSPATH="C:/cygwin/usr/local/Sapid-GCC/class/Japid3.jar;C:/cygwin/usr/local/Sapid-GCC/class/Wapid.jar;C:/cygwin/usr/local/Sapid-GCC/class/java-getopt-1.0.9.jar;C:/cygwin/usr/local/Sapid-GCC/class/jtool-1.2.jar;."
fi

if [ "${JAVA_HOME}" != "" ]; then
    CLASSPATH="${JAVA_HOME}/lib/tools.jar;${CLASSPATH}"
fi

# unlimit descriptors

# 
# Set PIDB environment variables.
# 

if [ ! -x "C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts" ]; then
    return
fi

SPD_DEF_BEFORE="`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -D`"
SPD_DEF_AFTER="`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -I`"

SPD_DEF_ANSI_BEFORE="`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -D -a`"
SPD_DEF_ANSI_AFTER="`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -I -a`"

SPD_DEF_GCC="`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -D -g`"
SPD_INCLUDE_PATH="-IC:/cygwin/usr/local/Sapid-GCC/fixed-include"

# Use include files fixed by gcc in Solaris.

if [ -x /bin/uname ]; then
    if [ "`/bin/uname`" = "SunOS" ];then
        SPD_DEF_AFTER="`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -I -l` ${SPD_DEF_AFTER}"
        SPD_DEF_ANSI_AFTER="`C:/cygwin/usr/local/Sapid-GCC/bin/sub/getGccOpts -I -a -l` ${SPD_DEF_ANSI_AFTER}"
    fi
fi
